/*
 * Queue.h - queue abstract data type.  (See Queue.c)
 * Copyright (C) 1992, 1991 Cornell University -- The Typhoon Project
 */
/* $Id: Queue.h,v 3.3 1993/08/02 04:06:54 dulitz Exp $ */

#ifndef _h_queue
#define _h_queue

struct _QueueNode
  {
    void *queue_item;
    struct _QueueNode *queue_next;
  };
typedef struct _QueueNode QueueNode;

#define qnITEM(q)		((q)->queue_item)
#define qnNEXT(q)		((q)->queue_next)

struct _Queue
  {
    QueueNode *queue_first, *queue_last;
    unsigned queue_length;
  };
typedef struct _Queue Queue;

#define qFIRST(q)		((q)->queue_first)
#define qLAST(q)		((q)->queue_last)
#define	qLENGTH(q)		((q)->queue_length)
#define qISEMPTY(q)		(qLENGTH (q) == 0)
#define qHEAD(q)                (qnITEM (qFIRST (q)))

#define FOR_Q(queue, type, item)					\
{									\
  Queue		*_Q_queue;						\
  QueueNode 	*_Q_qnode, *_Q_next;					\
  type 		 item;							\
									\
  if (queue != NULL)							\
    {									\
      _Q_queue = queue;							\
      for ( _Q_qnode = qFIRST(_Q_queue);				\
	    _Q_qnode;							\
            _Q_qnode = _Q_next )					\
        {								\
          _Q_next = qnNEXT(_Q_qnode);					\
          item    = (type) qnITEM(_Q_qnode); {

#define END_Q	}							\
        }								\
    }									\
}

/*
 * Queue.c functions
 */

extern Queue *create_Q (void);
extern void destroy_Q (Queue * Q);
extern QueueNode *add_Q (void *item, Queue * Q);
extern QueueNode *push_Q (void *item, Queue * Q);
extern void *get_Q (Queue * Q);

#endif /* _h_queue */
/* end of Queue.h */
