#include "cfg.h"
#include "tree.h"

static int SetSize;

void CdWalk(int bot,int top, FILE *fpo, BOOLEAN printp)

{
  while (bot != top) 
      {if (printp) fprintf(fpo, "%d ",bot);
       SetSize++;
       bot = pdom[bot];
     }
}

void CdCFGQuery(int src, int dst, FILE *fpo, BOOLEAN printp) 
                /* Source and destination nodes of CFG edge */

{ int node;
  SetSize = 0;
  if (printp) fprintf (fpo, "\nCD(%d -> %d) = { ", src, dst);
  node = pdom[src];
  if ANCESTOR(node,dst) 
    CdWalk(dst,pdom[src], fpo, printp);
  if (printp) fprintf (fpo, " }\n");
}


void CdChariotQuery(int Rt, FILE *fpo, BOOLEAN printp) /* Chariot number */
{ SetSize = 0;
  if (Rt > NumRoutes())
    {if (printp) fprintf(fpo, "\nChariot Number %d does not exist\n", Rt);
   }
  else 
    {Path P = path[Rt];
     int b = P.b;
     int t = P.t;
     if (printp) fprintf(fpo, "\nCD(%d -> %d) = { ", eSRC(P.l), eDST(P.l));
     CdWalk(b,t, fpo, printp );
     if (printp) fprintf (fpo, " }\n");
   }
}
  

int CdSize()
{
  return SetSize;
  }
