/* control flow graph data structures */

#ifndef NULL
#define NULL  0
#endif

#define TRUE  1
#define FALSE 0

extern int NumNodes,NumEdges,ENDNum;


#define NMAX 40000
#define EMAX 60000

struct _Node
{
  struct _Edge *preds;
  struct _Edge *succs;
};

typedef struct _Node Node;

#define nPREDS(n)    ((n).preds)
#define nSUCCS(n)    ((n).succs)

struct _Edge
{
  int index;
  int src, dst;
  struct _Edge *next_pred;
  struct _Edge *next_succ;
};

typedef struct _Edge Edge;

#define eINDEX(e)      ((e)->index)
#define eSRC(e)        ((e)->src)
#define eDST(e)        ((e)->dst)
#define eNEXTPRED(e)   ((e)->next_pred)
#define eNEXTSUCC(e)   ((e)->next_succ)

struct _Cfg
{
  int N, E, EI;
  Node *node;  /* array of nodes */
  Edge *edge;  /* array of edges */
};

typedef struct _Cfg Cfg;
 
#define cfgNODE(c,i)     ((c)->node[(i)])
#define cfgEDGE(c,i)     ((c)->edge[(i)])

/* internal macros */
#define cfgNODES(c)      ((c)->node)
#define cfgEDGES(c)      ((c)->edge)
#define cfgEI(c)         ((c)->EI)

Cfg *init_cfg (int N, int E);
void connect_nodes (Cfg *cfg, int src, int dst);

void free_cfg(Cfg *cfg);

void BuildRomanChariots(Cfg *cfg);

Cfg *lattice_cfg (void); 

Cfg *repeat_cfg (void);

Cfg *tarjan_cfg (void);

Cfg *tarjan2_cfg (void);

Cfg *tarjan4_cfg (void);

Cfg *tarjan3_cfg (void);

Cfg *simple_cfg (void);

Cfg *pingali_cfg(void);

Cfg *rcj_cfg(void);

Cfg *simple_cfg2(void);

Cfg *simple_cfg3(void);

Cfg *simple_cfg4(void);

Cfg *read_cfg (void);

void all_spec ();

/* end of cfg.h */
