#include <stdio.h>
#include <assert.h>
#include <sys/times.h>
#include <unistd.h>
#include "cfg.h"
#include "set.h"
#include "tree.h"


#define MAXRUNS 100

/*Storage for statistics */

  double t_cdeq[MAXRUNS], t_pdom[MAXRUNS], t_cyceq[MAXRUNS], t_conds[MAXRUNS];
  double t_cdeq_total, t_cyceq_total, t_pdom_total, t_conds_total;
  double t_cdeq_ave, t_cyceq_ave, t_pdom_ave, t_conds_ave;
  int cd_hist[1000], conds_hist[1000];


void experiment(Cfg * cfg, double alpha, FILE *fpo, BOOLEAN printp)
{   
  int i, RUNS, checksum;
  struct tms tms1, tms2, tms3;

  long clk_tck = sysconf (_SC_CLK_TCK);

/*
  printf ("RUNS: ");
  scanf("%d", &RUNS);
*/
 
/******************************************************************************/
  postdom (cfg);
  if (printp) fprintf(fpo,"\n\nHeight of pdom tree: %d \n", PdomHt());

  ConstructRomanChariots(cfg);
  if (printp) fprintf(fpo,"Number of Chariot Routes: %d \n", NumRoutes());

/******************************************************************************/
  CdCFGQuery (1,2,fpo,printp); /*CFG edge from Node 1 to Node 2 */
  if (printp) fprintf(fpo,"CD Set Size: %d\n", CdSize());

  CdChariotQuery(3,fpo,printp); /*Chariot Route Number 3 */
  if (printp) fprintf(fpo,"CD Set Size: %d\n", CdSize());

/******************************************************************************/
  CondsPreprocessing (alpha); /*Use alpha = 1.0 */
  if (printp) fprintf(fpo,"\n\nCache Size for APT: %d\n\n", CacheSize());

  /*Perform a conds query at all nodes */ 
  for (i=1; i<=NumNodes; i++)
    { int v = bfs[i];
      CondsQuery(v,fpo,printp);
      if (printp) fprintf (fpo,"Size of Conds Set = %d\n",CondsSize());
    };

/******************************************************************************/
  CdequivPreprocessing(); 

  /*Print all cdequiv regions */
  if (printp) fprintf(fpo,"Number of nonEMPTY regions is %d\n", numregions);
  for (i = 1; i <= NumNodes; i++)
    { int v = bfs[i];
      CdequivQuery(v, fpo, printp);
    }

}


