/* set.c  DS  2/5/93 */

/*
 * 
 * abstract data type  INT_SET
 * 
 */
#include <assert.h>
#include "set.h"

struct element elements[SMAX];
INT_SET freelist = NULLSET;

void init_INT_SET ()
{
  INT_SET s1, next = NULLSET;
  int i;

  for (i=0; i<SMAX; i++)
    {
      s1 = &elements[i];
      s1->next = next;
      next = s1;
    }
  freelist = next;
}

INT_SET add(int v, INT_SET s)
{
  INT_SET s1;

  assert(freelist != NULLSET);
  s1 = freelist;
  freelist = freelist->next;
  s1->value = v;
  s1->next = s;
  return s1;
}

INT_SET add_unique(int v, INT_SET s)
{
  INT_SET s1;

  if (s == NULLSET)
    return add(v, s);
  else 
    {
      for (s1=s; TRUE; s1 = s1->next)
	{
	  if (s1->value == v)
	    return s;
	  if (s1->next == NULLSET)
	    break;
	}
      s1->next = add(v, NULLSET);
      return s;
    }
}
  
INT_SET delete(INT_SET s)
{
  INT_SET s1;
  
  assert (s != NULLSET);
  s1 = s->next;

  /* free s */
  s->next = freelist;
  freelist = s;

  return s1;
}

