/*
 * stack.h - Stack abstract data type.  (See stack.c)
 * Copyright (C) 1993 Cornell University -- The Typhoon Project
 */

#ifndef _h_stack
#define _h_stack

#define STMAX 60000

struct _StackNode
  {
    int size, name;
    struct _StackNode *next, *back, *qnext;
    int edgeindex;
  };
typedef struct _StackNode StackNode;

#define snSIZE(s)   ((s)->size)
#define snNAME(s)   ((s)->name)
#define snNEXT(s)   ((s)->next)
#define snBACK(s)   ((s)->back)
#define snQNEXT(s)  ((s)->qnext)
#define snEDGEINDEX(s)   ((s)->edgeindex)

struct _Stack
  {
    union {
      StackNode *top;
      struct _Stack *next;
    } u;

    StackNode *bot;
    int size;
  };
typedef struct _Stack Stack;

#define sTOP(s)		((s)->u.top)
#define sBOT(s)         ((s)->bot)
#define	sSIZE(s)	((s)->size)
#define sISEMPTY(s)	(sSIZE (s) == 0)
#define sNEXT(s)        ((s)->u.next)

/*
 * Stack.c functions
 */
extern void init_S (void);
extern Stack *create_S (void);
extern void destroy_S (Stack * S);
extern StackNode *push_S (Stack * S, int ei);
extern void delete_S (StackNode *sn, Stack * S);
extern void combine_S (Stack * S1, Stack * S2);

#endif /* _h_stack */
/* end of stack.h */
