#include <stdio.h>
#include <assert.h>
#include "set.h"

/*Allocated in main.c and set by pdom.c*/
extern int pdom[NMAX], pdom1[NMAX], pdom2[NMAX];
extern int pdom_child[NMAX], pdom_sibling[NMAX];

void postdom(Cfg *);
int PdomHt(); /*return height of pdom tree */
#define ANCESTOR(a,b) ((a)==0 ||(pdom1[(a)]<=pdom1[(b)] && pdom1[(b)]<=pdom2[(a)]))

/*used by conds and by cdequiv */
struct _Path {
  int b, t; /*bottom and top of route */
  Edge *l;  /*CFG edge corresponding to route */
};
typedef struct _Path Path;
extern Path path[NMAX];
extern int npaths;


struct _List {
  struct _Path *pi;
  struct _List *next;
};
typedef struct _List List;

extern int bfs[NMAX]; /*bfs[i] = node number of node labeled i by bfs */
extern int Hi[NMAX];  /*Highest node reached by edge out of node */
extern List *L[NMAX]; /*List of chariot routes cached at node */
extern boundary[NMAX];
extern int region[NMAX];
extern int numregions;

int NumRoutes();
void ConstructRomanChariots(Cfg *);

void experiment(Cfg *, double, FILE *, BOOLEAN);

void CdCFGQuery(int, int, FILE *, BOOLEAN);
void CdChariotQuery(int, FILE *, BOOLEAN);
int CdSize();

void CondsPreprocessing(double alpha);
int CacheSize();

void CondsQuery(int, FILE *,BOOLEAN);
int CondsSize();

void CdequivPreprocessing();
void CdequivQuery(int, FILE *, BOOLEAN);
